#!/usr/bin/env python2
# -*- coding: utf-8 -*-

# MIT License
#
# Copyright (c) 2020 Cesar Pereida García, Sohaib ul Hassan, Nicola Tuveri,
# Iaroslav Gridin, Alejandro Cabrera Aldaya, Billy Bob Brumley
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

import sys
import ijson

try:
    fp = open(sys.argv[1], 'rb')
except:
    print 'Usage: python2 %s <path_to_json>' % (sys.argv[0])
    sys.exit(1)

d = {}

for v in ijson.items(fp, 'item'):
    hash_function = v['hash_function']
    digest = v['hash']
    order = v['order']
    private_key = v['private_key']
    public_key = v['public_key']
    sig_r = v['sig_r']
    sig_s = v['sig_s']
    sig_nonce = v['sig_nonce']
    nonce_bits = v['nonce_bits']
    latency = v['latency']
    if nonce_bits not in d:
        d[nonce_bits] = []
    d[nonce_bits].append(latency)

fp.close()

print 'Len\tMedian'

for bit in sorted(d.keys()):
    d[bit].sort()
    print '%d\t%d' % (bit, d[bit][len(d[bit])//2])

